<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { getDefaultSettings } from "./settings";
  const dispatch = createEventDispatcher();

  export let settings: GameSettings = getDefaultSettings();

  let currentSettings = settings;

  let numberOfColors: 5 | 6 = settings.sixColors ? 6 : 5;

  $: if (settings !== currentSettings) {
    numberOfColors = settings.sixColors ? 6 : 5;
    currentSettings = settings;
  }

  export let readonly: boolean = false;

  function handleChange() {
    if (!readonly) {
      const newSettings: GameSettings = { sixColors: numberOfColors === 6 };
      dispatch("settings_change", newSettings);
    }
  }
</script>

<section>
  <fieldset>
    <legend>Player counts</legend>

    <ul>
      <li>
        <label class="player-count" for="player-count-2">
          <input id="player-count-2" type="checkbox" checked disabled /> 2
        </label>
      </li>
    </ul>
    <ul>
      <li><small>Recommended: 2</small></li>
      <li><small>Best: 2</small></li>
    </ul>
  </fieldset>

  <fieldset>
    <legend>Number of colors</legend>

    <ul>
      <label>
        <input
          type="radio"
          value={5}
          disabled={readonly}
          bind:group={numberOfColors}
          on:change={handleChange}
        />
        5 <span class="option-description">(normal game)</span>
      </label>
      <label>
        <input
          type="radio"
          value={6}
          disabled={readonly}
          bind:group={numberOfColors}
          on:change={handleChange}
        />
        6 <span class="option-description">(longer game)</span>
      </label>
    </ul>
  </fieldset>
</section>

<style>
  section {
    padding-bottom: 1rem;
    display: grid;
    row-gap: 1em;
  }

  fieldset {
    border: 0;
    padding: 0;
    margin: 0;
  }
  legend {
    padding: 0;
    font-weight: 500;
  }
  ul {
    margin: 0;
    display: flex;
    flex-wrap: wrap;
    column-gap: 1em;
  }
  li {
    white-space: nowrap;
  }

  .option-description {
    font-size: 90%;
    filter: opacity(90%);
  }

  small {
    filter: opacity(90%);
  }
</style>
